package com.backendsys.modules.common.config.redis;

import org.redisson.Redisson;
import org.redisson.api.RedissonClient;
import org.redisson.config.Config;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class RedissonConfig {

    @Value("${spring.data.redis.host}")
    private String redisHost;

    @Value("${spring.data.redis.port}")
    private String redisPort;

    @Value("${spring.data.redis.password}")
    private String redisPassword;

    /**
     * 所有对Redisson的使用都是通过RedissonClient对象
     * @return
     */
    @Bean(destroyMethod = "shutdown")
    public RedissonClient redissonClient(){
        try {
            // 创建配置 指定redis地址及节点信息
            Config config = new Config();
            // config.useSingleServer().setAddress("XXX.XX.XX.X(redis地址):端口").setPassword("xxxxxxxxx");
            config.useSingleServer().setAddress("redis://" + redisHost + ":" + redisPort).setPassword(redisPassword);
            // 根据config创建出RedissonClient实例
            RedissonClient redissonClient = Redisson.create(config);
            return redissonClient;
        } catch (Exception e) {
            System.err.println("Unable to initialize RedissonClient: " + e.getMessage());
            return null; // 或者返回一个默认的 RedissonClient 实例，或者返回其他适当的值
        }
    }

//    // 引入Redisson可能会出现项目启动失败问题解决
//    // https://blog.csdn.net/bengbuguang4321/article/details/121951650
//    @Bean
//    public RedissonClient redissonClient() {
//        RedissonClient redissonClient = new RedissonClientTemporary();
//        return redissonClient;
//    }

}
